diff --git a/checkers/src/checkers/units/model/Measure.java b/checkers/src/checkers/units/model/Measure.java
new file mode 100644
index 0000000..1cd0072
--- /dev/null
+++ b/checkers/src/checkers/units/model/Measure.java
@@ -0,0 +1,287 @@
+package checkers.units.model;
+
+public abstract class Measure implements Comparable<Measure> {
+    public static class SimpleMeasure extends Measure {
+	private final double scale;
+	private final Unit unit;
+
+	public SimpleMeasure(double scale, Unit unit) {
+	    this.scale = scale;
+	    this.unit = unit;
+	}
+
+	@Override
+	public int compareTo(Measure that) {
+	    Measure thatInMyUnits = that.inUnit(unit);
+	    if (scale == thatInMyUnits.getScale()) {
+		return 0;
+	    }
+	    if (scale < thatInMyUnits.getScale()) {
+		return -1;
+	    }
+	    return 1;
+	}
+
+	@Override
+	public Measure div(double scale) {
+	    return make(this.getScale() / scale, this.getUnit());
+	}
+
+	@Override
+	public Measure div(Measure that) {
+	    final Measure[] result = new Measure[1];
+	    that.accept(new Visitor() {
+		@Override
+		public void visitSimple(SimpleMeasure that) {
+		    result[0] = unit.div(that.getUnit()).times(
+			    scale / that.getScale());
+		}
+
+		@Override
+		public void visitZero(ZeroMeasure that) {
+		    result[0] = that;
+		}
+	    });
+	    return result[0];
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+	    if (!(obj instanceof Measure)) {
+		return false;
+	    }
+	    return compareTo((Measure) obj) == 0;
+	}
+
+	@Override
+	public Measure exp(int k) {
+	    return make(Math.pow(scale, k), unit.exp(k));
+	}
+
+	@Override
+	public double getScale() {
+	    return scale;
+	}
+
+	public Unit getUnit() {
+	    return unit;
+	}
+
+	@Override
+	public int hashCode() {
+	    return ((Double) scale).hashCode() * 17 + unit.hashCode();
+	}
+
+	@Override
+	public Measure inUnit(Unit newUnit) {
+	    SimpleMeasure scaleMeasure = (SimpleMeasure) newUnit.div(unit);
+	    if (scaleMeasure.getUnit() != Unit.SCALAR) {
+		throw new IncompatibleUnitsError(unit, newUnit);
+	    }
+	    return make(scale * scaleMeasure.getScale(), newUnit);
+	}
+
+	@Override
+	public Measure minus(Measure that) {
+	    Measure thatScaled = that.inUnit(unit);
+	    return make(scale - thatScaled.getScale(), unit);
+	}
+
+	@Override
+	public Measure plus(Measure that) {
+	    Measure thatScaled = that.inUnit(unit);
+	    return make(scale + thatScaled.getScale(), unit);
+	}
+
+	@Override
+	public Measure times(double scale) {
+	    return make(this.getScale() * scale, this.getUnit());
+	}
+
+	@Override
+	public Measure times(Measure that) {
+	    final Measure[] result = new Measure[1];
+	    that.accept(new Visitor() {
+		@Override
+		public void visitSimple(SimpleMeasure that) {
+		    result[0] = unit.times(that.getUnit()).times(
+			    scale * that.getScale());
+		}
+
+		@Override
+		public void visitZero(ZeroMeasure that) {
+		    result[0] = that;
+		}
+	    });
+	    return result[0];
+	}
+
+	@Override
+	public String toString() {
+	    if (unit == Unit.SCALAR) {
+		return "" + scale;
+	    } else {
+		return scale + " " + unit;
+	    }
+	}
+
+	@Override
+	void accept(Visitor visitor) {
+	    visitor.visitSimple(this);
+	}
+    }
+
+    private interface Visitor {
+	void visitSimple(SimpleMeasure measure);
+
+	void visitZero(ZeroMeasure measure);
+    }
+
+    private static class ZeroMeasure extends Measure {
+	@Override
+	public int compareTo(Measure o) {
+	    final int[] result = new int[1];
+	    o.accept(new Visitor() {
+		@Override
+		public void visitSimple(SimpleMeasure measure) {
+		    if (measure.getScale() > 0) {
+			result[0] = -1;
+		    } else {
+			result[0] = 1;
+		    }
+		}
+
+		@Override
+		public void visitZero(ZeroMeasure measure) {
+		    result[0] = 0;
+		}
+	    });
+	    return result[0];
+	}
+
+	@Override
+	public Measure div(double scale) {
+	    if (scale == 0.0) {
+		throw new ArithmeticException("division by zero");
+	    }
+	    return this;
+	}
+
+	@Override
+	public Measure div(Measure that) {
+	    return this;
+	}
+
+	@Override
+	public Measure exp(int k) {
+	    if (k == 0) {
+		throw new ArithmeticException("raising 0 to the 0 power");
+	    }
+	    return this;
+	}
+
+	@Override
+	public double getScale() {
+	    return 0;
+	}
+
+	@Override
+	public Measure inUnit(Unit unit) {
+	    return this;
+	}
+
+	@Override
+	public Measure minus(Measure that) {
+	    final Measure[] result = new Measure[1];
+	    that.accept(new Visitor() {
+
+		@Override
+		public void visitSimple(SimpleMeasure measure) {
+		    result[0] = new SimpleMeasure(-measure.getScale(), measure
+			    .getUnit());
+		}
+
+		@Override
+		public void visitZero(ZeroMeasure measure) {
+		    result[0] = ZERO;
+		}
+
+	    });
+	    return result[0];
+	}
+
+	@Override
+	public Measure plus(Measure that) {
+	    return that;
+	}
+
+	@Override
+	public Measure times(double scale) {
+	    return this;
+	}
+
+	@Override
+	public Measure times(Measure that) {
+	    return this;
+	}
+
+	@Override
+	public String toString() {
+	    return "0.0";
+	}
+
+	@Override
+	void accept(Visitor visitor) {
+	    visitor.visitZero(this);
+	}
+    }
+
+    /**
+     * The zero measure. It has no units, and it is compatible with all other
+     * measures.
+     */
+    private static Measure ZERO = new ZeroMeasure();
+
+    public static Measure make(double scale) {
+	return make(scale, Unit.SCALAR);
+    }
+
+    public static Measure make(double scale, Unit unit) {
+	if (scale == 0) {
+	    return ZERO;
+	} else {
+	    return new SimpleMeasure(scale, unit);
+	}
+    }
+
+    protected Measure() {
+    }
+
+    public abstract Measure div(double scale);
+
+    public abstract Measure div(Measure that);
+
+    public Measure div(Unit unit) {
+	return this.div(make(1.0, unit));
+    }
+
+    public abstract Measure exp(int k);
+
+    public abstract double getScale();
+
+    public abstract Measure inUnit(Unit unit);
+
+    public abstract Measure minus(Measure that);
+
+    public abstract Measure plus(Measure that);
+
+    public abstract Measure times(double scale);
+
+    public abstract Measure times(Measure that);
+
+    public Measure times(Unit unit) {
+	return this.times(make(1.0, unit));
+    }
+
+    abstract void accept(Visitor visitor);
+}
diff --git a/checkers/src/checkers/units/model/StandardUnits.java b/checkers/src/checkers/units/model/StandardUnits.java
new file mode 100644
index 0000000..4e9618b
--- /dev/null
+++ b/checkers/src/checkers/units/model/StandardUnits.java
@@ -0,0 +1,26 @@
+package checkers.units.model;
+
+import checkers.units.model.*;
+import checkers.units.model.Dimension.SimpleDimension;
+import checkers.units.model.Unit.SimpleUnit;
+import checkers.units.quals.Dim;
+
+public class StandardUnits {
+    public static final SimpleDimension Length = new SimpleDimension("Length");
+    public static final SimpleDimension Time = new SimpleDimension("Time");
+
+    public static final @Dim(Time)
+    Unit s = new SimpleUnit(Time, 1.0, "s");
+
+    public static final @Dim(Time)
+    Unit min = new SimpleUnit(Time, 60.0, "min");
+
+    public static final @Dim(Length)
+    Unit m = new SimpleUnit(Length, 1.0, "m");
+
+    public static final @Dim(Length)
+    Unit km = new SimpleUnit(Length, 1000.0, "km");
+
+    public static final @Dim(Length.div(Time))
+    Measure mps = m.div(s);
+}
diff --git a/checkers/src/checkers/units/model/Unit.java b/checkers/src/checkers/units/model/Unit.java
new file mode 100644
index 0000000..7b0c502
--- /dev/null
+++ b/checkers/src/checkers/units/model/Unit.java
@@ -0,0 +1,479 @@
+package checkers.units.model;
+
+import checkers.units.model.Dimension.SimpleDimension;
+
+import java.util.*;
+
+/**
+ * A unit of measure, such as the meter or the second. It has a
+ * {@link Dimension}, and it has a scale factor within that {@link Dimension}
+ * that can be used to convert to another unit in the same dimension.
+ */
+public abstract class Unit {
+    public static class SimpleUnit extends Unit {
+	private final SimpleDimension dimension;
+	private final String name;
+	private final double scale;
+
+	public SimpleUnit(SimpleDimension dimension, double scale, String name) {
+	    this.dimension = dimension;
+	    this.scale = scale;
+	    this.name = name;
+	}
+
+	@Override
+	public SimpleDimension getDimension() {
+	    return dimension;
+	}
+
+	@Override
+	public double getScale() {
+	    return scale;
+	}
+
+	@Override
+	public String toString() {
+	    return name;
+	}
+
+	@Override
+	void accept(Visitor visitor) {
+	    visitor.visitSimple(this);
+	}
+
+	@Override
+	public Measure div(Unit that) {
+	    final Measure[] result = new Measure[1];
+	    that.accept(new Visitor() {
+		@Override
+		public void visitCompound(CompoundUnit that) {
+		    List<SimpleUnit> newNumer = new ArrayList<SimpleUnit>();
+		    newNumer.add(SimpleUnit.this);
+		    newNumer.addAll(that.getDenom());
+		    result[0] = normalize(newNumer, that.getNumer());
+		}
+
+		@Override
+		public void visitScalar(ScalarUnit that) {
+		    result[0] = Measure.make(1.0, SimpleUnit.this);
+		}
+
+		@Override
+		public void visitSimple(SimpleUnit that) {
+		    result[0] = normalize(singleton(SimpleUnit.this),
+			    singleton(that));
+		}
+	    });
+	    return result[0];
+	}
+
+	@Override
+	public Unit exp(int k) {
+	    if (k == 0) {
+		return SCALAR;
+	    }
+	    List<SimpleUnit> copies = Collections.nCopies(Math.abs(k), this);
+	    if (k > 0) {
+		return new CompoundUnit(copies, NO_UNITS);
+	    } else {
+		return new CompoundUnit(NO_UNITS, copies);
+	    }
+	}
+
+	@Override
+	public Measure times(Unit that) {
+	    final Measure[] result = new Measure[1];
+	    that.accept(new Visitor() {
+		@Override
+		public void visitCompound(CompoundUnit that) {
+		    List<SimpleUnit> newNumer = new ArrayList<SimpleUnit>();
+		    newNumer.add(SimpleUnit.this);
+		    newNumer.addAll(that.getNumer());
+		    result[0] = normalize(newNumer, that.getDenom());
+		}
+
+		@Override
+		public void visitScalar(ScalarUnit that) {
+		    result[0] = Measure.make(1.0, SimpleUnit.this);
+		}
+
+		@Override
+		public void visitSimple(SimpleUnit that) {
+		    result[0] = normalize(singleton(SimpleUnit.this),
+			    singleton(that));
+		}
+	    });
+	    return result[0];
+	}
+    }
+
+    private static List<SimpleDimension> extractDimensions(
+	    List<SimpleUnit> units) {
+	List<SimpleDimension> dims = new ArrayList<SimpleDimension>(units
+		.size());
+	for (SimpleUnit unit : units) {
+	    dims.add(unit.getDimension());
+	}
+	return dims;
+    }
+
+    private static class CompoundUnit extends Unit {
+	private final List<SimpleUnit> denom;
+	private final List<SimpleUnit> numer;
+	private final Dimension dimension;
+
+	public CompoundUnit(List<SimpleUnit> numer, List<SimpleUnit> denom) {
+	    this.numer = numer;
+	    this.denom = denom;
+
+	    this.dimension = new Dimension.CompoundDimension(
+		    extractDimensions(numer), extractDimensions(denom));
+	}
+
+	public List<SimpleUnit> getDenom() {
+	    return denom;
+	}
+
+	@Override
+	public Dimension getDimension() {
+	    return dimension;
+	}
+
+	public List<SimpleUnit> getNumer() {
+	    return numer;
+	}
+
+	@Override
+	public double getScale() {
+	    double scale = 1;
+	    for (SimpleUnit unit : numer) {
+		scale *= unit.getScale();
+	    }
+	    for (SimpleUnit unit : denom) {
+		scale /= unit.getScale();
+	    }
+	    return scale;
+	}
+
+	@Override
+	public String toString() {
+	    StringBuilder sb = new StringBuilder();
+	    if (numer.size() == 0) {
+		sb.append("ScalarDimension");
+	    } else {
+		boolean first = true;
+		for (SimpleUnit dim : numer) {
+		    if (first) {
+			first = false;
+		    } else {
+			sb.append("*");
+		    }
+		    sb.append(dim);
+		}
+	    }
+	    if (denom.size() > 0) {
+		sb.append("/");
+		if (denom.size() > 1) {
+		    sb.append("(");
+		}
+		boolean first = true;
+		for (SimpleUnit dim : denom) {
+		    if (first) {
+			first = false;
+		    } else {
+			sb.append("*");
+		    }
+		    sb.append(dim);
+		}
+		if (denom.size() > 1) {
+		    sb.append(")");
+		}
+	    }
+	    return sb.toString();
+	}
+
+	@Override
+	void accept(Visitor visitor) {
+	    visitor.visitCompound(this);
+	}
+
+	@Override
+	public Measure div(Unit that) {
+	    final Measure[] result = new Measure[1];
+
+	    that.accept(new Visitor() {
+		@Override
+		public void visitCompound(CompoundUnit that) {
+		    List<SimpleUnit> newNumer = new ArrayList<SimpleUnit>();
+		    newNumer.addAll(numer);
+		    newNumer.addAll(that.getDenom());
+
+		    List<SimpleUnit> newDenom = new ArrayList<SimpleUnit>();
+		    newDenom.addAll(denom);
+		    newDenom.addAll(that.getNumer());
+
+		    result[0] = normalize(newNumer, newDenom);
+		}
+
+		@Override
+		public void visitScalar(ScalarUnit that) {
+		    result[0] = Measure.make(1.0, CompoundUnit.this);
+		}
+
+		@Override
+		public void visitSimple(SimpleUnit that) {
+		    List<SimpleUnit> newDenom = new ArrayList<SimpleUnit>();
+		    newDenom.addAll(denom);
+		    newDenom.add(that);
+		    result[0] = normalize(numer, newDenom);
+		}
+	    });
+
+	    return result[0];
+	}
+
+	@Override
+	public Unit exp(int k) {
+	    if (k == 0) {
+		return SCALAR;
+	    }
+	    if (k > 0) {
+		return new CompoundUnit(UnitsModelUtils.copies(k, numer),
+			UnitsModelUtils.copies(k, denom));
+	    }
+	    return new CompoundUnit(UnitsModelUtils.copies(-k, denom),
+		    UnitsModelUtils.copies(-k, numer));
+	}
+
+	@Override
+	public Measure times(Unit that) {
+	    final Measure[] result = new Measure[1];
+
+	    that.accept(new Visitor() {
+		@Override
+		public void visitCompound(CompoundUnit that) {
+		    List<SimpleUnit> newNumer = new ArrayList<SimpleUnit>();
+		    newNumer.addAll(numer);
+		    newNumer.addAll(that.getNumer());
+
+		    List<SimpleUnit> newDenom = new ArrayList<SimpleUnit>();
+		    newDenom.addAll(denom);
+		    newDenom.addAll(that.getDenom());
+
+		    result[0] = normalize(newNumer, newDenom);
+		}
+
+		@Override
+		public void visitScalar(ScalarUnit that) {
+		    result[0] = Measure.make(1.0, CompoundUnit.this);
+		}
+
+		@Override
+		public void visitSimple(SimpleUnit that) {
+		    List<SimpleUnit> newNumer = new ArrayList<SimpleUnit>();
+		    newNumer.addAll(numer);
+		    newNumer.add(that);
+		    result[0] = normalize(newNumer, denom);
+		}
+	    });
+
+	    return result[0];
+	}
+    }
+
+    private static class ScalarUnit extends Unit {
+	@Override
+	public Measure div(Unit that) {
+	    final Measure[] result = new Measure[1];
+	    that.accept(new Visitor() {
+		@Override
+		public void visitCompound(CompoundUnit that) {
+		    result[0] = normalize(that.getDenom(), that.getNumer());
+		}
+
+		@Override
+		public void visitScalar(ScalarUnit that) {
+		    result[0] = Measure.make(1.0, SCALAR);
+		}
+
+		@Override
+		public void visitSimple(SimpleUnit that) {
+		    result[0] = normalize(NO_UNITS, singleton(that));
+		}
+
+	    });
+	    return result[0];
+	}
+
+	@Override
+	public Unit exp(int k) {
+	    return this;
+	}
+
+	@Override
+	public Dimension getDimension() {
+	    return Dimension.SCALAR;
+	}
+
+	@Override
+	public double getScale() {
+	    return 1.0;
+	}
+
+	@Override
+	public Measure times(Unit that) {
+	    return Measure.make(1.0, that);
+	}
+
+	@Override
+	public String toString() {
+	    return "ScalarUnit";
+	}
+
+	@Override
+	void accept(Visitor visitor) {
+	    visitor.visitScalar(this);
+	}
+    }
+
+    private interface Visitor {
+	void visitCompound(CompoundUnit unit);
+
+	void visitScalar(ScalarUnit unit);
+
+	void visitSimple(SimpleUnit unit);
+    }
+
+    @SuppressWarnings("unchecked")
+    public static final List<SimpleUnit> NO_UNITS = Collections.EMPTY_LIST;
+
+    public static Unit SCALAR = new ScalarUnit();
+
+    private static Measure normalize(List<SimpleUnit> numer,
+	    List<SimpleUnit> denom) {
+	List<SimpleUnit> nums = new ArrayList<SimpleUnit>(numer);
+	List<SimpleUnit> dens = new ArrayList<SimpleUnit>(denom);
+
+	/*
+	 * Cancelling can cause the scale to be other than one, if units are
+	 * cancelled that have the same dimension but differenc scale.
+	 */
+	double scale = 1.0;
+
+	for (SimpleUnit d : denom) {
+	    SimpleUnit sameDim = null;
+	    for (SimpleUnit unit : nums) {
+		if (unit.getDimension().equals(d.getDimension())) {
+		    sameDim = unit;
+		    break;
+		}
+	    }
+	    if (sameDim != null) {
+		nums.remove(sameDim);
+		dens.remove(d);
+		scale = scale * sameDim.getScale() / d.getScale();
+	    }
+	}
+
+	nums = roughSort(nums);
+	dens = roughSort(dens);
+
+	if (nums.isEmpty() && dens.isEmpty()) {
+	    return Measure.make(scale, SCALAR);
+	}
+	if (nums.size() == 1 && dens.isEmpty()) {
+	    return Measure.make(scale, nums.get(0));
+	}
+	return Measure.make(scale, new CompoundUnit(nums, dens));
+    }
+
+    private static List<SimpleUnit> roughSort(List<SimpleUnit> units) {
+	List<SimpleUnit> byDimension = roughSortByDimension(units);
+	return UnitsModelUtils.roughSort(byDimension);
+    }
+
+    private static List<SimpleUnit> roughSortByDimension(
+	    List<SimpleUnit> unsorted) {
+	List<SimpleUnit> unsortedLeft = new ArrayList<SimpleUnit>(unsorted);
+	List<SimpleUnit> newList = new ArrayList<SimpleUnit>(unsorted.size());
+
+	while (!unsortedLeft.isEmpty()) {
+	    SimpleUnit x = unsortedLeft.get(0);
+	    while (true) {
+		SimpleUnit sameDim = null;
+		for (SimpleUnit unit : unsortedLeft) {
+		    if (unit.getDimension() == x.getDimension()) {
+			sameDim = unit;
+			break;
+		    }
+		}
+		if (sameDim == null) {
+		    break;
+		}
+		newList.add(sameDim);
+		unsortedLeft.remove(sameDim);
+	    }
+	}
+	return newList;
+    }
+
+    private Unit() {
+    }
+
+    /**
+     * Divide two units. This returns a Measure, not just a Unit, because the
+     * result might need scaling in order to normalize the unit.
+     */
+    public abstract Measure div(Unit that);
+
+    /**
+     * Two units are equal if the have the same dimension and the same scale.
+     */
+    @Override
+    public boolean equals(Object object) {
+	if (!(object instanceof Unit)) {
+	    return false;
+	}
+	Unit that = (Unit) object;
+	return getDimension().equals(that.getDimension())
+		&& getScale() == that.getScale();
+    }
+
+    public abstract Unit exp(int k);
+
+    /**
+     * The general dimension of this unit, e.g. length or time. Units in the
+     * same dimension can be compared and can be used in arithmetic operations.
+     */
+    public abstract Dimension getDimension();
+
+    /**
+     * The relative scale of this unit within the dimension. Larger scales mean
+     * that each unit counts for more.
+     */
+    public abstract double getScale();
+
+    @Override
+    public int hashCode() {
+	int code = 41;
+	code = code * 17 + ((Double) getScale()).hashCode();
+	code = code * 17 + getDimension().hashCode();
+	return code;
+    }
+
+    public <T> List<T> singleton(T x) {
+	return Collections.singletonList(x);
+    }
+
+    public Measure times(double scale) {
+	return Measure.make(scale, this);
+    }
+
+    /**
+     * Multiply two units. This returns a Measure, not just a Unit, because the
+     * result might need scaling in order to normalize the unit.
+     */
+    public abstract Measure times(Unit that);
+
+    abstract void accept(Visitor visitor);
+}
diff --git a/checkers/src/checkers/units/model/UnitsModelUtils.java b/checkers/src/checkers/units/model/UnitsModelUtils.java
new file mode 100644
index 0000000..0c5db8a
--- /dev/null
+++ b/checkers/src/checkers/units/model/UnitsModelUtils.java
@@ -0,0 +1,36 @@
+package checkers.units.model;
+
+import java.util.*;
+
+/**
+ * Utilities for use within the units library. This class should not be accessed
+ * from outside the library.
+ */
+public class UnitsModelUtils {
+    /**
+     * Return a list with <code>n</code> copies of an input list.
+     */
+    static <T> List<T> copies(int n, List<T> list) {
+	List<T> copies = new ArrayList<T>();
+	for (int i = 0; i < n; i++) {
+	    copies.addAll(list);
+	}
+	return copies;
+    }
+
+    /**
+     * Rearrange a list so that equivalent items are next to each other.
+     */
+    public static <T> List<T> roughSort(List<T> unsorted) {
+	List<T> unsortedLeft = new ArrayList<T>(unsorted);
+	List<T> newList = new ArrayList<T>(unsorted.size());
+	while (!unsortedLeft.isEmpty()) {
+	    T x = unsortedLeft.get(0);
+	    while (unsortedLeft.contains(x)) {
+		newList.add(x);
+		unsortedLeft.remove(x);
+	    }
+	}
+	return newList;
+    }
+}
diff --git a/checkers/src/checkers/units/quals/Dim.java b/checkers/src/checkers/units/quals/Dim.java
new file mode 100644
index 0000000..d3c65e9
--- /dev/null
+++ b/checkers/src/checkers/units/quals/Dim.java
@@ -0,0 +1,39 @@
+/*
+ * Copyright 2009 Google Inc.
+ * 
+ * Licensed under the Apache License, Version 2.0 (the "License"); you may not
+ * use this file except in compliance with the License. You may obtain a copy of
+ * the License at
+ * 
+ * http://www.apache.org/licenses/LICENSE-2.0
+ * 
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+ * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+ * License for the specific language governing permissions and limitations under
+ * the License.
+ */
+package checkers.units.quals;
+
+import checkers.quals.TypeQualifier;
+import checkers.units.model.Dimension;
+
+import java.lang.annotation.*;
+
+/**
+ * An annotation on a type indicating the dimensions of that type.
+ * The argument to the annotation must match the following syntax:
+ * <pre>
+ *   dim := Dimension.SCALAR
+ *       |  (any static final field)
+ *       |  dim.times(dim)
+ *       |  dim.div(dim)
+ *       |  dim.exp(integer_literal)
+ * </pre>
+ */
+@TypeQualifier
+@Retention(RetentionPolicy.CLASS)
+public @interface Dim {
+    @AllowNonConstant
+    Dimension value();
+}
diff --git a/checkers/src/checkers/util/AnnotationUtils.java b/checkers/src/checkers/util/AnnotationUtils.java
index fb96811..d8ca0cf 100644
--- a/checkers/src/checkers/util/AnnotationUtils.java
+++ b/checkers/src/checkers/util/AnnotationUtils.java
@@ -349,7 +349,7 @@ public class AnnotationUtils {
             if (p == null || !p)
                 return null;
 
-            /*@Nullable*/ R r = Enum.<R>valueOf(enumType, (/*@NonNull*/ String)c.getSimpleName().toString());
+            /*@Nullable*/ R r = Enum.<R>valueOf(enumType, c.getSimpleName().toString());
             assert r != null; /*nninvariant*/
             values.add(r);
             return null;
@@ -699,6 +699,10 @@ public class AnnotationUtils {
         public AnnotationBuilder setValue(CharSequence elementName, String value) {
             return setValue(elementName, (Object)value);
         }
+        
+        public AnnotationBuilder setValue(CharSequence elementName, Tree value) {
+            return setValue(elementName, (Object) value);
+        }
 
         public AnnotationBuilder setValue(CharSequence elementName, TypeMirror value) {
             assertNotBuilt();
@@ -762,7 +766,10 @@ public class AnnotationUtils {
             assertNotBuilt();
             AnnotationValue val = createValue(value);
             ExecutableElement var = findElement(key);
-            checkSubtype(var.getReturnType(), value);
+            if (!(value instanceof Tree)) {
+        	// Ideally the tree's type would be checked, but that's not trivial
+                checkSubtype(var.getReturnType(), value);
+            }
             elementValues.put(var, val);
             return this;
         }
@@ -847,6 +854,9 @@ public class AnnotationUtils {
 
                 @SuppressWarnings("unchecked")
                 @Override
+                /**
+                 * TODO(spoon) how to deal with visitors to nodes with ASTs
+                 */
                 public <R, P> R accept(AnnotationValueVisitor<R, P> v, P p) {
                     if (value instanceof AnnotationMirror)
                         return v.visitAnnotation((AnnotationMirror)value, p);
diff --git a/checkers/tests/src/tests/UnitsModelTest.java b/checkers/tests/src/tests/UnitsModelTest.java
new file mode 100644
index 0000000..d2531d7
--- /dev/null
+++ b/checkers/tests/src/tests/UnitsModelTest.java
@@ -0,0 +1,74 @@
+package tests;
+
+import static checkers.units.model.StandardUnits.*;
+import checkers.units.model.*;
+
+import junit.framework.TestCase;
+
+/**
+ * This tests the units checker's model.
+ */
+public class UnitsModelTest extends TestCase {
+    public void testBasics() {
+	{
+	    Measure threeMeters = m.times(3);
+	    Measure fourMeters = m.times(4);
+	    Measure sum = threeMeters.plus(fourMeters);
+	    assertEquals(m.times(7), sum);
+	}
+
+	{
+	    Measure threeMeters = m.times(3);
+	    Measure fourSeconds = s.times(4);
+	    try {
+		threeMeters.plus(fourSeconds);
+		fail("Should have raised an incompatible units exception");
+	    } catch (IncompatibleUnitsError e) {
+		// expected
+	    }
+	}
+
+	{
+	    Measure threeMeters = m.times(3);
+	    Measure fourMeters = m.times(4);
+	    Measure diff = threeMeters.minus(fourMeters);
+	    assertEquals(m.times(-1), diff);
+	}
+
+	{
+	    Measure threeMeters = m.times(3);
+	    Measure fourSeconds = s.times(4);
+	    try {
+		threeMeters.minus(fourSeconds);
+		fail("Should have raised an incompatible units exception");
+	    } catch (IncompatibleUnitsError e) {
+		// expected
+	    }
+	}
+
+	{
+	    Measure threeMeters = m.times(3);
+	    Measure fourSeconds = s.times(4);
+	    assertEquals(Measure.make(12).times(m.times(s)), threeMeters
+		    .times(fourSeconds));
+	}
+
+	{
+	    Measure eightMeters = m.times(8);
+	    Measure fourSeconds = s.times(4);
+	    assertEquals(Measure.make(2).times(m.div(s)), eightMeters
+		    .div(fourSeconds));
+	}
+    }
+
+    public void testDimensionToString() {
+	assertEquals("ScalarDimension", Dimension.SCALAR.toString());
+	assertEquals("Length", Length.toString());
+	assertEquals("Length*Length", Length.times(Length).toString());
+	assertEquals("1/Length", Dimension.SCALAR.div(Length).toString());
+	assertEquals("1/(Length*Time*Time)", Dimension.SCALAR.div(
+		Length.times(Time).times(Time)).toString());
+	assertEquals("Length*Length/Time", Length.times(Length).div(Time)
+		.toString());
+    }
+}
diff --git a/checkers/tests/units/Silly.java b/checkers/tests/units/Silly.java
new file mode 100644
index 0000000..931b031
--- /dev/null
+++ b/checkers/tests/units/Silly.java
@@ -0,0 +1,7 @@
+import java.lang.annotation.AllowNonConstant;
+
+@interface Silly {
+    // Test: type Integer should be allowed iff @AllowNonConstant is applied
+     @AllowNonConstant
+    int[] value();
+}
\ No newline at end of file
diff --git a/checkers/tests/units/Units.java b/checkers/tests/units/Units.java
new file mode 100644
index 0000000..36a55db
--- /dev/null
+++ b/checkers/tests/units/Units.java
@@ -0,0 +1,41 @@
+import checkers.units.quals.Dim;
+import checkers.units.model.*;
+import static checkers.units.StandardUnits.*;
+import static checkers.units.model.Dimension.SCALAR;
+
+class Units {
+    public @Dim(Length.div(Time))
+    Measure speed(@Dim(Length) Measure distance, @Dim(Time) Measure time) {
+	// return distance.div(time);
+	return null;
+    }
+
+    int plusOne(int x) {
+	return x + 1;
+    }
+
+    public void badUnits() {
+	// TODO(spoon) make a separate test case for things so malformed they
+	// don't even make it to the checker
+	// @Dim(Length + 1)
+	// Measure malformed = null;
+
+	// @Dim(m)
+	// Measure notAdimension = null;
+
+	@Dim(Length)
+	Measure distanceGood = m.times(3);
+
+	@Dim(Length)
+	Measure distanceBad = s.times(3);
+
+	@Dim(Length.div(Time))
+	Measure speedGood = m.times(3).div(s.times(1));
+
+	@Dim(Length.div(Time))
+	Measure speedBad = s.times(3).div(m.times(2));
+
+	@Dim(SCALAR)
+	Measure scalarGood = m.times(3).div(m.times(3));
+    }
+}
\ No newline at end of file
diff --git a/langtools/src/share/classes/com/sun/javadoc/AnnotationValue.java b/langtools/src/share/classes/com/sun/javadoc/AnnotationValue.java
index c55c65d..e6e1120 100644
--- a/langtools/src/share/classes/com/sun/javadoc/AnnotationValue.java
+++ b/langtools/src/share/classes/com/sun/javadoc/AnnotationValue.java
@@ -43,6 +43,7 @@ public interface AnnotationValue {
      *     <li> <code>FieldDoc</code> (representing an enum constant)
      *     <li> <code>AnnotationDesc</code>
      *     <li> <code>AnnotationValue[]</code>
+     *     <li> <code>ExpressionTree</code>
      * </ul>
      *
      * @return the value.
diff --git a/langtools/src/share/classes/com/sun/tools/apt/mirror/declaration/AnnotationProxyMaker.java b/langtools/src/share/classes/com/sun/tools/apt/mirror/declaration/AnnotationProxyMaker.java
index e1b5ba8..07c46bb 100644
--- a/langtools/src/share/classes/com/sun/tools/apt/mirror/declaration/AnnotationProxyMaker.java
+++ b/langtools/src/share/classes/com/sun/tools/apt/mirror/declaration/AnnotationProxyMaker.java
@@ -241,6 +241,10 @@ class AnnotationProxyMaker {
                 value = null;   // indicates a type mismatch
             }
         }
+        
+        public void visitExpression(Attribute.Expression e) {
+            value = null; // TODO(spoon)
+        }
 
         public void visitError(Attribute.Error e) {
             value = null;       // indicates a type mismatch
@@ -253,9 +257,11 @@ class AnnotationProxyMaker {
         private void typeMismatch(final Method method, final Attribute attr) {
             value = new ExceptionProxy() {
                 private static final long serialVersionUID = 8473323277815075163L;
+                @Override
                 public String toString() {
                     return "<error>";   // eg:  @Anno(value=<error>)
                 }
+                @Override
                 protected RuntimeException generateException() {
                     return new AnnotationTypeMismatchException(method,
                                 attr.type.toString());
@@ -282,10 +288,12 @@ class AnnotationProxyMaker {
             ex = new MirroredTypeException(t);
         }
 
+        @Override
         public String toString() {
             return ex.getQualifiedName();
         }
 
+        @Override
         public int hashCode() {
             TypeMirror t = ex.getTypeMirror();
             return (t != null)
@@ -293,6 +301,7 @@ class AnnotationProxyMaker {
                     : ex.getQualifiedName().hashCode();
         }
 
+        @Override
         public boolean equals(Object obj) {
             TypeMirror t = ex.getTypeMirror();
             return t != null &&
@@ -301,6 +310,7 @@ class AnnotationProxyMaker {
                         ((MirroredTypeExceptionProxy) obj).ex.getTypeMirror());
         }
 
+        @Override
         protected RuntimeException generateException() {
             return (RuntimeException) ex.fillInStackTrace();
         }
@@ -324,10 +334,12 @@ class AnnotationProxyMaker {
             ex = new MirroredTypesException(ts);
         }
 
+        @Override
         public String toString() {
             return ex.getQualifiedNames().toString();
         }
 
+        @Override
         public int hashCode() {
             Collection<TypeMirror> ts = ex.getTypeMirrors();
             return (ts != null)
@@ -335,6 +347,7 @@ class AnnotationProxyMaker {
                     : ex.getQualifiedNames().hashCode();
         }
 
+        @Override
         public boolean equals(Object obj) {
             Collection<TypeMirror> ts = ex.getTypeMirrors();
             return ts != null &&
@@ -343,6 +356,7 @@ class AnnotationProxyMaker {
                       ((MirroredTypesExceptionProxy) obj).ex.getTypeMirrors());
         }
 
+        @Override
         protected RuntimeException generateException() {
             return (RuntimeException) ex.fillInStackTrace();
         }
